require "netposti/version"
require "netposti/inbox"

require "mechanize"

module Netposti
  class LoginError < StandardError; end

  LOGIN_URL = 'https://www.posti.fi/omatpalvelut/posti/login'.freeze

  def self.login(opts)
    agent = Mechanize.new
    agent.pluggable_parser.default = Mechanize::Download

    page = agent.get(LOGIN_URL)
    inbox = page.form_with(:name => 'loginForm') do |f|
      f['login.username'] = opts[:username]
      f['login.password'] = opts[:password]
    end.click_button

    raise LoginError unless inbox.uri.path.match(/messageListPage/)

    Inbox.new(inbox)
  end
end
