require "netposti/message"

module Netposti
  class Inbox

    def initialize(inbox)
      @inbox = inbox
    end

    def number_of_unread_messages
      @inbox.search('.unread').count
    end

    def messages
      @_messages ||= @inbox.links_with(:href => /(.*?)listview(.*?)openMessage$/).lazy.map { |message| Message.new(message.click) }
    end

    def unread_messages
      messages.first(number_of_unread_messages)
    end

    def last_message
      messages.first(1).first
    end
  end
end
