module Netposti
  class Message

    def initialize(message)
      @message = message
    end

    def sender
      @message.search('#message-detail-header-content .sender').text
    end

    def date
      @message.search('#message-detail-header-content .date').text
    end

    def subject
      @message.form.field_with(:name => 'messageSubjectTextField').value
    end

    def attachment_url
      pdf_icon_value = @message.search('.small-pdf-icon').first.attributes['onclick'].value
      download_path = pdf_icon_value.match(/window.location.href='.(.*?)'/)[1].split('-', 2).last
      @message.uri.to_s + '-' + download_path
    end

    def download_attachment(filename = nil)
      @message.mech.get(attachment_url).save(filename)
    end

    def to_hash
      {
        sender: sender,
        date: date,
        subject: subject,
        attachment_url: attachment_url
      }
    end

    def to_s
      "#{date}: #{sender} - #{subject}"
    end

  end
end
